Index: codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN.env
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN.env	(revision 332)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN.env	(revision 333)
@@ -1,10 +1,13 @@
 #!/bin/bash
-module unload netcdf
-module unload hdf5
+module unload netcdf hdf5 intel bullxmpi
+
+module load intel/14.0.4.211
+module load bullxmpi/1.2.8.3   
+module load hdf5/1.8.14_parallel_bullxmpi 
+module load netcdf/bullxmpi/4.3.3-rc2
+module load netcdf/bullxmpi/fortran-4.4.1_4.3.3-rc2
+
+export HDF5_INC_DIR=$HDF5HOME/include
+export HDF5_LIB_DIR=$HDF5HOME/lib
 export NETCDF_INC_DIR="$PWD/../NETCDF4/include"
 export NETCDF_LIB_DIR="$PWD/../NETCDF4/lib"
-export HDF5_INC_DIR="/opt/software/libraries/hdf5/hdf51.8.14/include"
-export HDF5_LIB_DIR="/opt/software/libraries/hdf5/hdf51.8.14/lib"
-module load intel/14.0.4.211
-module load bullmpi/1.2.8.1
-module load hdf5/1.8.14_parallel
Index: codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN_INTELMPI.env
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN_INTELMPI.env	(revision 333)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN_INTELMPI.env	(revision 333)
@@ -0,0 +1,13 @@
+#!/bin/bash
+module unload netcdf hdf5 intel bullxmpi
+
+module load intel/14.0.4.211
+module load intelmpi  
+module load hdf5/1.8.14_parallel_intelmpi
+module load netcdf/intelmpi/4.3.3-rc2
+module load netcdf/intelmpi/fortran-4.4.1_4.3.3-rc2
+
+export HDF5_INC_DIR=$HDF5HOME/include
+export HDF5_LIB_DIR=$HDF5HOME/lib
+export NETCDF_INC_DIR="$PWD/../NETCDF4/include"
+export NETCDF_LIB_DIR="$PWD/../NETCDF4/lib"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN_INTELMPI.fcm
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN_INTELMPI.fcm	(revision 333)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN_INTELMPI.fcm	(revision 333)
@@ -0,0 +1,24 @@
+################################################################################
+###################        Projet xios - xmlioserver       #####################
+################################################################################
+
+%CCOMPILER      mpicc
+%FCOMPILER      mpif90
+%LINKER         mpif90  -nofor-main
+
+%BASE_CFLAGS    -diag-disable 1125 -diag-disable 279
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+%DEV_CFLAGS     -g -traceback
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
+
+%BASE_FFLAGS    -D__NONE__ 
+%PROD_FFLAGS    -O3
+%DEV_FFLAGS     -g -O2 -traceback
+%DEBUG_FFLAGS   -g -traceback
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++
+
+%CPP            mpicc -EP
+%FPP            cpp -P
+%MAKE           gmake
Index: codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN_INTELMPI.path
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN_INTELMPI.path	(revision 333)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/arch/arch-X64_OCCIGEN_INTELMPI.path	(revision 333)
@@ -0,0 +1,15 @@
+NETCDF_INCDIR="-I$NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L$NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I$HDF5_INC_DIR"
+HDF5_LIBDIR="-L$HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz"
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/compile_curie
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/compile_curie	(revision 333)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/compile_curie	(revision 333)
@@ -0,0 +1,1 @@
+./make_xios --arch X64_CURIE --j 8 --full
Index: codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/compile_occigen_intelmpi
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/compile_occigen_intelmpi	(revision 333)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/XIOS/compile_occigen_intelmpi	(revision 333)
@@ -0,0 +1,1 @@
+./make_xios --arch X64_OCCIGEN_INTELMPI --j 8